// DlgConnect.cpp : implementation file
//

#include "stdafx.h"
#include "connect.h"
#include "DlgConnect.h"

#include "cstringt.h"
#include <iostream>
#include <fstream>
#include <string>
#include "direct.h"

#include <errno.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDlgConnect dialog




CDlgConnect::CDlgConnect(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgConnect::IDD, pParent)
   , m_ZPlate(0)
   , m_ScanZoneSize(0)
   , m_ZCS2(0)
   , m_BrickNumber(0)
   , m_strFileCSSpotMarkSet(_T(""))
   , m_strFileLateralMarkSet(_T(""))
   , m_PlateNumber(0)
   , m_strFileWorkingFolder(_T(""))
   , m_strFileRawDataFolder(_T(""))
   , m_strFileTlgDataFolder(_T(""))
   , m_strScanningConfig(_T(""))
   , m_strScanServerIP(_T(""))
   , m_dPositionTol(0)
   , m_dSlopeTol(0)
   , m_dIncreaseWithSlope(0)
   , m_MCPosTol(0)
   , m_MCSlopeTol(0)
   , m_strMCResults(_T(""))
   , m_strMCScanningConfig(_T(""))
   , m_strTrackSelResults(_T(""))
   , m_TrialNumber(0)
   , m_MarkSetType( kCSSPOT )
   , m_strMergeResults(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDlgConnect::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Text(pDX, IDC_EDIT_FILEPREDCS2, m_strFilePredCS2);
   DDX_Text(pDX, IDC_EDIT_MESSAGE, m_strMessage);
   DDX_Text(pDX, IDC_EDIT_ZBRICK, m_ZPlate);
   DDX_Text(pDX, IDC_EDIT_SCANZONESIZE, m_ScanZoneSize);
   DDV_MinMaxDouble(pDX, m_ScanZoneSize, 0, 150000);
   DDX_Text(pDX, IDC_EDIT_ZCS2, m_ZCS2);
   DDX_Text(pDX, IDC_EDIT_BRICKNUMBER, m_BrickNumber);
   DDX_Text(pDX, IDC_EDIT_CSSPOT_MARKSET, m_strFileCSSpotMarkSet);
   DDX_Text(pDX, IDC_EDIT_LATERAL_MARKSET, m_strFileLateralMarkSet);
   DDX_Text(pDX, IDC_EDIT_PLATENUMBER, m_PlateNumber);
   DDX_Text(pDX, IDC_EDIT_WORKINGFOLDER, m_strFileWorkingFolder);
   DDX_Text(pDX, IDC_EDIT_RAWDATAFOLDER, m_strFileRawDataFolder);
   DDX_Text(pDX, IDC_EDIT_TLGDATAFOLDER, m_strFileTlgDataFolder);
   DDX_Text(pDX, IDC_EDIT_SCANNINGCONFIG, m_strScanningConfig);
   DDX_Text(pDX, IDC_EDIT_SCANSERVERIP, m_strScanServerIP);
   DDV_MinMaxDouble(pDX, m_ZPlate, -99999999, 99999999);
   DDX_Text(pDX, IDC_EDIT_POSTOL, m_dPositionTol);
   DDX_Text(pDX, IDC_EDIT_SLOPETOL, m_dSlopeTol);
   DDX_Text(pDX, IDC_EDIT_INCREASEWITHSLOPE, m_dIncreaseWithSlope);
   DDX_Text(pDX, IDC_EDIT_MC_POSTOL, m_MCPosTol);
   DDX_Text(pDX, IDC_EDIT_MC_SLOPETOL, m_MCSlopeTol);
   DDX_Text(pDX, IDC_EDIT_MCRESULTS, m_strMCResults);
   DDX_Text(pDX, IDC_EDIT_MCSCANNINGCONFIG, m_strMCScanningConfig);
   DDX_Text(pDX, IDC_EDIT_TRACKSELRESULTS, m_strTrackSelResults);
   DDX_Text(pDX, IDC_EDIT_TRIAL, m_TrialNumber);
   DDX_Radio(pDX, IDC_MARKSET_RADIO_CSSPOT, m_MarkSetType);
   DDX_Text(pDX, IDC_EDIT_MERGERESULTS, m_strMergeResults);
}

BEGIN_MESSAGE_MAP(CDlgConnect, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
   ON_BN_CLICKED(IDC_BTN_LOADPREDCS2, &CDlgConnect::OnBnClickedBtnLoadpredCS2)
   ON_BN_CLICKED(IDC_BTN_START, &CDlgConnect::OnBnClickedBtnStart)
   ON_EN_CHANGE(IDC_EDIT_BRICKNUMBER, &CDlgConnect::OnEnChangeEditBrickNumber)
   ON_BN_CLICKED(IDC_BTN_CSSPOT_MARKSET, &CDlgConnect::OnBnClickedBtnCSSpotMarkSet)
   ON_BN_CLICKED(IDC_BTN_LATERAL_MARKSET, &CDlgConnect::OnBnClickedBtnLateralMarkSet)
   ON_BN_CLICKED(IDC_BTN_WORKINGFOLDER, &CDlgConnect::OnBnClickedBtnWorkingFolder)
   ON_BN_CLICKED(IDC_BTN_RAWDATAFOLDER, &CDlgConnect::OnBnClickedBtnRawdataFolder)
   ON_BN_CLICKED(IDC_BTN_TLGDATAFOLDER, &CDlgConnect::OnBnClickedBtnTlgdataFolder)
   ON_BN_CLICKED(IDC_BTN_SCANNINGCONFIG, &CDlgConnect::OnBnClickedBtnScanningconfig)
   ON_CBN_SELCHANGE(IDC_COMBO_SCANSERVER, &CDlgConnect::OnCbnSelchangeComboScanserver)
   ON_BN_CLICKED(IDC_BTN_LOADPARAMETERS, &CDlgConnect::OnBnClickedBtnLoadparameters)
   ON_BN_CLICKED(IDC_BTN_TRACKSEL, &CDlgConnect::OnBnClickedBtnTracksel)
   ON_BN_CLICKED(IDC_BTN_MANUALCHECKS, &CDlgConnect::OnBnClickedBtnManualchecks)
   ON_EN_CHANGE(IDC_EDIT_PLATENUMBER, &CDlgConnect::OnEnChangeEditPlateNumber)
   ON_EN_CHANGE(IDC_EDIT_TRIAL, &CDlgConnect::OnEnChangeEditTrial)
   ON_BN_CLICKED(IDC_MARKSET_RADIO_CSSPOT, &CDlgConnect::OnBnClickedMarksetRadioCsspot)
   ON_BN_CLICKED(IDC_MARKSET_RADIO_LATERAL, &CDlgConnect::OnBnClickedMarksetRadioLateral)
   ON_BN_CLICKED(IDC_BTN_MERGERESULTS, &CDlgConnect::OnBnClickedBtnMergeresults)
END_MESSAGE_MAP()

//___________________________________________________________________________//

// CDlgConnect message handlers

//___________________________________________________________________________//

BOOL CDlgConnect::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

   m_ZCS2           =     0.0 ;
   m_ZPlate         = -4500.0 ;
   m_ScanZoneSize   =  1000.0 ;
   m_PlateNumber    =    57   ;
   m_BrickNumber    =     0   ;

   m_dPositionTol       = 300     ;
   m_dSlopeTol          =   0.030 ;
   m_dIncreaseWithSlope =   3     ;

   m_MCPosTol     = 1000  ;
   m_MCSlopeTol   = 1.000 ;

   GetDlgItem( IDC_MARKSET_RADIO_CSSPOT ) ->SendMessage( BN_CLICKED ) ;
   OnBnClickedMarksetRadioCsspot() ;

   // fill the ComboBox
   ((CComboBox*) GetDlgItem(IDC_COMBO_SCANSERVER))->AddString( "-----" );
   ((CComboBox*) GetDlgItem(IDC_COMBO_SCANSERVER))->AddString( "MIC 1" );
   ((CComboBox*) GetDlgItem(IDC_COMBO_SCANSERVER))->AddString( "MIC 2" );
   ((CComboBox*) GetDlgItem(IDC_COMBO_SCANSERVER))->AddString( "MIC 3" );
   ((CComboBox*) GetDlgItem(IDC_COMBO_SCANSERVER))->AddString( "MIC 4" );
   ((CComboBox*) GetDlgItem(IDC_COMBO_SCANSERVER))->AddString( "MIC 5" );
   
   if ( fPar.ReadConfig( "connect.ini" )==0 ) {      
      m_strMessage.AppendFormat( "read parameters from connect.ini ...\r\n") ;
   } else {      
      fPar.SetDefaults() ;      
      m_strMessage.AppendFormat( "read parameters from connect.ini failed !\r\nload defaults...\r\n" ) ;
   }   
   m_strMessage.AppendFormat( "%s", fPar.ShowPar() );   

   UpdateData(FALSE) ;
      
   return TRUE;  // return TRUE  unless you set the focus to a control
}
//___________________________________________________________________________//
void CDlgConnect::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
//___________________________________________________________________________//
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CDlgConnect::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//___________________________________________________________________________//
// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDlgConnect::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
//___________________________________________________________________________//
void CDlgConnect::WriteLine( const char *format, ... )
{
	va_list args ;
	int len ;
	char* buffer;

	va_start ( args, format ) ;
	len = _vscprintf( format, args ) +1 ; // _vscprintf doesn't count terminating '\0'

	buffer = new char[len];
	vsprintf_s( buffer, len*sizeof(char), format, args ) ;

	//SendDlgItemMessage(IDC_MN_MESSAGEBOX  , WM_SETTEXT, 0, (LPARAM) buffer );
   CString str; str.Format( "%s\r\n", buffer );
   m_strMessage += str ;
   UpdateData(FALSE);

	delete [] buffer ;
}
//___________________________________________________________________________//
int CDlgConnect::System( const char *format, ... )
{
	va_list args ;
	int len ;
	char* buffer;

	va_start ( args, format ) ;
	len = _vscprintf( format, args ) +1 ; // _vscprintf doesn't count terminating '\0'

	buffer = new char[len];
	vsprintf_s( buffer, len*sizeof(char), format, args ) ;

	//SendDlgItemMessage(IDC_MN_MESSAGEBOX  , WM_SETTEXT, 0, (LPARAM) buffer );
   WriteLine( buffer );

   int res = -1 ;
   try{
      res = system( buffer ) ;
   } catch (...) {
      res = -1 ;
   }
	delete [] buffer ;
      
   //WriteLine("return code : %d", res) ;
   return res ;
}
//____________________________________________________________________________//
void CDlgConnect::OnEnChangeEditBrickNumber()
{
   UpdateData() ;

   m_strFilePredCS2       .Format( fPar.cs2file , m_BrickNumber ) ;
   m_strFileCSSpotMarkSet .Format( fPar.csspot_markset   , m_BrickNumber , m_BrickNumber ) ;
   m_strFileLateralMarkSet .Format( fPar.lateral_markset , m_BrickNumber , m_BrickNumber ) ;
   m_strFileWorkingFolder .Format( fPar.workdir , m_BrickNumber ) ;
   m_strFileRawDataFolder .Format( fPar.rawdir  , m_BrickNumber ) ; 
   m_strFileTlgDataFolder .Format( fPar.tlgdir  , m_BrickNumber ) ; 

   m_strMCResults         .Format( fPar.mcresultspath, m_BrickNumber, m_PlateNumber ) ;
   m_strTrackSelResults   .Format( fPar.foundpath    , m_BrickNumber, m_PlateNumber ) ;
   m_strMergeResults      .Format( fPar.mergeresults , m_BrickNumber ) ;

   UpdateData(FALSE) ;
}
//___________________________________________________________________________//
void CDlgConnect::OnEnChangeEditPlateNumber()
{
   UpdateData() ;

   m_strMCResults         .Format( fPar.mcresultspath, m_BrickNumber, m_PlateNumber ) ;
   m_strTrackSelResults   .Format( fPar.foundpath    , m_BrickNumber, m_PlateNumber ) ;

   if ( m_PlateNumber >0 && m_PlateNumber < 58 ) 
   {
      m_ZPlate  = -4500 + 1300 * (m_PlateNumber - 57 ) ;

      if (m_PlateNumber != 57 )
         OnBnClickedMarksetRadioLateral() ;
      else 
         OnBnClickedMarksetRadioCsspot() ;
   }


   UpdateData(FALSE) ;
}
//___________________________________________________________________________//
void CDlgConnect::OnEnChangeEditTrial()
{
   UpdateData() ;

   m_strMCResults         .Format( fPar.mcresultspath, m_BrickNumber, m_PlateNumber ) ;
   m_strTrackSelResults   .Format( fPar.foundpath    , m_BrickNumber, m_PlateNumber ) ;

   UpdateData(FALSE) ;
}
//___________________________________________________________________________//
void CDlgConnect::OnCbnSelchangeComboScanserver()
{
   UpdateData() ;

   int sel = ( (CComboBox*) GetDlgItem( IDC_COMBO_SCANSERVER ) )->GetCurSel()  ;

   if ( sel == 0 )
   {
      m_strScanningConfig = "" ;
      m_strMCScanningConfig = "" ;
      m_strScanServerIP   = "" ; 
   } else {
      m_strScanningConfig   .Format( fPar.scanconf   , sel ) ;
      m_strScanServerIP     .Format( fPar.scanip     , sel ) ; 
      m_strMCScanningConfig .Format( fPar.mcscanconf , sel ) ; 
   }

   UpdateData(FALSE) ;
}
//___________________________________________________________________________//
DWORD                    kFileDlgFlags         = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ;

const char               kFileDlgDefExt_txt[]  = "txt" ;
const char BASED_CODE    kFileDlgFilters_txt[] = "Text Files (*.txt)|*.txt|All Files (*.*)|*.*||";

const char               kFileDlgDefExt_xml[]  = "xml" ;
const char BASED_CODE    kFileDlgFilters_xml[] = "XML Files (*.xml)|*.xml|All Files (*.*)|*.*||";


void CDlgConnect::OnBnClickedBtnLoadpredCS2()
{
      CFileDialog dlgFile( TRUE, kFileDlgDefExt_txt, m_strFilePredCS2 , kFileDlgFlags, kFileDlgFilters_txt );
      INT_PTR nResult = dlgFile.DoModal() ;
      m_strFilePredCS2 = dlgFile.GetPathName().GetBuffer() ;
      UpdateData(FALSE) ; 
}
void CDlgConnect::OnBnClickedBtnCSSpotMarkSet()
{
      CFileDialog dlgFile( TRUE, kFileDlgDefExt_txt, m_strFileCSSpotMarkSet, kFileDlgFlags, kFileDlgFilters_txt );
      INT_PTR nResult = dlgFile.DoModal() ;
      m_strFileCSSpotMarkSet = dlgFile.GetPathName().GetBuffer() ;
      UpdateData(FALSE) ; 
}
void CDlgConnect::OnBnClickedBtnLateralMarkSet()
{
      CFileDialog dlgFile( TRUE, kFileDlgDefExt_txt, m_strFileLateralMarkSet, kFileDlgFlags, kFileDlgFilters_txt );
      INT_PTR nResult = dlgFile.DoModal() ;
      m_strFileLateralMarkSet = dlgFile.GetPathName().GetBuffer() ;
      UpdateData(FALSE) ; 
}

void CDlgConnect::OnBnClickedBtnScanningconfig()
{
      CFileDialog dlgFile( TRUE, kFileDlgDefExt_xml, m_strScanningConfig, kFileDlgFlags, kFileDlgFilters_xml );
      INT_PTR nResult = dlgFile.DoModal() ;
      m_strScanningConfig = dlgFile.GetPathName().GetBuffer() ;
      UpdateData(FALSE) ; 
}

void CDlgConnect::OnBnClickedBtnRawdataFolder()
{
    //Folder Browser code.
    BROWSEINFO bi;
    ZeroMemory(&bi, sizeof(BROWSEINFO));
    bi.hwndOwner = m_hWnd;
    bi.ulFlags   = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE ;
    LPITEMIDLIST pidl = SHBrowseForFolder(&bi);
    BOOL bRet = FALSE;
    TCHAR szFolder[MAX_PATH*2];
    szFolder[0] = _T('\0');
    if (pidl)
    {
        if (SHGetPathFromIDList(pidl, szFolder))
        {
            bRet = TRUE;
        }
        IMalloc *pMalloc = NULL; 
        if (SUCCEEDED(SHGetMalloc(&pMalloc)) && pMalloc) 
        {  
            pMalloc->Free(pidl);  
            pMalloc->Release(); 
        }
    }
    //Return value is kept in szFolder.

   m_strFileRawDataFolder = szFolder ;
   UpdateData(FALSE) ; 
}

void CDlgConnect::OnBnClickedBtnTlgdataFolder()
{
    //Folder Browser code.
    BROWSEINFO bi;
    ZeroMemory(&bi, sizeof(BROWSEINFO));
    bi.hwndOwner = m_hWnd;
    bi.ulFlags   = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE ;
    LPITEMIDLIST pidl = SHBrowseForFolder(&bi);
    BOOL bRet = FALSE;
    TCHAR szFolder[MAX_PATH*2];
    szFolder[0] = _T('\0');
    if (pidl)
    {
        if (SHGetPathFromIDList(pidl, szFolder))
        {
            bRet = TRUE;
        }
        IMalloc *pMalloc = NULL; 
        if (SUCCEEDED(SHGetMalloc(&pMalloc)) && pMalloc) 
        {  
            pMalloc->Free(pidl);  
            pMalloc->Release(); 
        }
    }
    //Return value is kept in szFolder.

   m_strFileTlgDataFolder = szFolder ;
   UpdateData(FALSE) ; 
}


void CDlgConnect::OnBnClickedBtnWorkingFolder()
{
    //Folder Browser code.
    BROWSEINFO bi;
    ZeroMemory(&bi, sizeof(BROWSEINFO));
    bi.hwndOwner = m_hWnd;
    bi.ulFlags   = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE ;
    LPITEMIDLIST pidl = SHBrowseForFolder(&bi);
    BOOL bRet = FALSE;
    TCHAR szFolder[MAX_PATH*2];
    szFolder[0] = _T('\0');
    if (pidl)
    {
        if (SHGetPathFromIDList(pidl, szFolder))
        {
            bRet = TRUE;
        }
        IMalloc *pMalloc = NULL; 
        if (SUCCEEDED(SHGetMalloc(&pMalloc)) && pMalloc) 
        {  
            pMalloc->Free(pidl);  
            pMalloc->Release(); 
        }
    }
    //Return value is kept in szFolder.

   m_strFileWorkingFolder = szFolder ;
   UpdateData(FALSE) ; 
}
//___________________________________________________________________________//
 CString CDlgConnect::ZoneListFileName() 
 {
   UpdateData();
   
   CString listfname ;
   listfname.Format("%s\\%02d_zonelist.txt", 
      m_strFileWorkingFolder.GetBuffer(), m_PlateNumber ) ;

   return listfname ;
 }
//___________________________________________________________________________//
 CString CDlgConnect::ManualCheckZoneListFileName() 
 {
   UpdateData();
   
   CString listfname ;
   listfname.Format("%s\\%02d_zonelist_for_manualcheck_%02d.txt", 
      m_strFileWorkingFolder.GetBuffer(), m_PlateNumber , m_TrialNumber) ;

   return listfname ;
 }
//___________________________________________________________________________//
 CString CDlgConnect::FoundFileName() 
 {
   UpdateData();
   
   CString fname ;
   fname.Format( m_strTrackSelResults.GetBuffer() , m_BrickNumber, m_PlateNumber ) ;

   return fname ;
 }
//___________________________________________________________________________//
 CString CDlgConnect::ManualCheckResultsFileName() 
 {
   UpdateData();
   
   CString fname ;
   fname.Format( m_strMCResults.GetBuffer() , m_BrickNumber, m_PlateNumber ) ;

   return fname ;
 }
//___________________________________________________________________________//
void CDlgConnect::OnBnClickedBtnStart()
{
   if ( ! UpdateData() ) return ;

   m_strMessage = "" ;

   try{

      // PREPARE SCAN ZONES
      ReadPredictions( m_strFilePredCS2.GetBuffer() ) ;
      CreateWorkingFolders() ;
      ProjectPredictions( m_ZPlate - m_ZCS2 ) ;
      EvalScanZones ( m_ScanZoneSize, m_ScanZoneSize ) ;
      
      CString map;
      if (m_MarkSetType == kCSSPOT )
         map = m_strFileCSSpotMarkSet ;
      else
         map = m_strFileLateralMarkSet ;

      CreateZoneListFile( ZoneListFileName().GetBuffer(), m_BrickNumber, m_PlateNumber, 
         map.GetBuffer() , m_strFileRawDataFolder.GetBuffer() , m_TrialNumber ) ;

      // LAUNCH SCAN + LINK
      if ( ! fPred.IsNewTrial( FoundFileName().GetBuffer(), m_TrialNumber ) ) 
      {
         WriteLine("\r\nTrial number already exist. Please change Trial number." ) ;
      } else if ( m_strScanServerIP.IsEmpty() ) {
         WriteLine("\r\nTo start scanning, please select a Scan Server IP" ) ;
      } else {
         LaunchListScan( m_strScanServerIP.GetBuffer() , ZoneListFileName().GetBuffer(), m_strScanningConfig.GetBuffer() ) ;
   	   LaunchBatchLink( m_strFileRawDataFolder.GetBuffer() , 
            m_strFileTlgDataFolder.GetBuffer() , m_PlateNumber , m_TrialNumber ) ;
      }
 
   } catch(...) { }
   
}
//___________________________________________________________________________//
void CDlgConnect::OnBnClickedBtnTracksel()
{
   if ( ! UpdateData() ) return ;

   ReadPredictions( m_strFilePredCS2.GetBuffer() ) ;
   ProjectPredictions( m_ZPlate - m_ZCS2 ) ;

   if ( ! fPred.IsNewTrial( FoundFileName().GetBuffer(), m_TrialNumber ) ) 
   {
      WriteLine("\r\nTrial number already exist. Please change Trial number." ) ;
   }
   else 
   {
      LaunchTLGSel( m_dPositionTol, m_dSlopeTol, m_dIncreaseWithSlope,
                    m_strFileTlgDataFolder.GetBuffer() , 
                    m_BrickNumber, m_PlateNumber, m_TrialNumber ) ;

      LaunchTLG2TXT( FoundFileName().GetBuffer(), 
                     m_strFileTlgDataFolder.GetBuffer() , 
                     m_BrickNumber, m_PlateNumber, m_TrialNumber  ) ;
   }
}
//___________________________________________________________________________//
void CDlgConnect::OnBnClickedBtnManualchecks()
{
   if ( ! UpdateData() ) return ;

   ReadPredictions( m_strFilePredCS2.GetBuffer() ) ;
   ProjectPredictions( m_ZPlate - m_ZCS2 ) ;

   CString map;
   if (m_MarkSetType == kCSSPOT )
      map = m_strFileCSSpotMarkSet ;
   else
      map = m_strFileLateralMarkSet ;

   LaunchTLG2TXTForManualCheck( 
                 ManualCheckZoneListFileName().GetBuffer(),
                 ManualCheckResultsFileName().GetBuffer(),
                 m_strFileTlgDataFolder.GetBuffer() , 
                 m_BrickNumber, m_PlateNumber , m_TrialNumber, 
                 map.GetBuffer() ,
                 m_MCPosTol, m_MCSlopeTol) ;

   // LAUNCH MANUAL CHECK + LINK
      if ( m_strScanServerIP.IsEmpty() ) {
         WriteLine("\r\nTo start manual check, please select a Scan Server IP in the scan box" ) ;
      } else {
         LaunchListScan( m_strScanServerIP.GetBuffer() , ManualCheckZoneListFileName().GetBuffer(), m_strMCScanningConfig.GetBuffer() ) ;
      }
 

}
//___________________________________________________________________________//
BOOL CDlgConnect::UpdateData(BOOL bSaveAndValidate) 
{
   BOOL ret_val = CDialog::UpdateData( bSaveAndValidate) ;
   CEdit* ce = (CEdit*) GetDlgItem( IDC_EDIT_MESSAGE ) ;
   ce->LineScroll( ce->GetLineCount() );

   return ret_val ;
};

//___________________________________________________________________________//
void CDlgConnect::ReadPredictions(const char* fname)
{
   // READ PREDICTIONS
   WriteLine( "Load Predictions..." );
   try {
      fPred.ReadPredictions( fname ) ;
      WriteLine( fPred.Print() );
   } catch(...) { 
      WriteLine( "Error reading predictions" );   
      throw "error reading file"; 
   }
}
//___________________________________________________________________________//
void CDlgConnect::ProjectPredictions( double z ) 
{
   // PROJECT PREDICTIONS
   WriteLine( "Project Predictions to: %f ", z );
   fPred.ProjectTo( z ) ;
   WriteLine( fPred.Print() );
}
//___________________________________________________________________________//
void CDlgConnect::EvalScanZones( double size_x, double size_y ) 
{
   // EVALUATE SCAN ZONES
   WriteLine(  "Evaluate Scan Zones ( X  %f , Y  %f)\r\n", size_x/2., size_y/2. );
   fPred.EvaluateScanZones( size_x, size_y ) ;
   WriteLine( fPred.PrintScanZones() ); 
}
//___________________________________________________________________________//
void CDlgConnect::CreateWorkingFolders()
{
   CreateFolder ( m_strFileWorkingFolder ) ;
   CreateFolder ( m_strFileRawDataFolder ) ;
   CreateFolder ( m_strFileTlgDataFolder ) ;

}
//___________________________________________________________________________//
void CDlgConnect::CreateFolder( CString folder )
{
   try {
      WriteLine ( "Create Folder: %s" , folder.GetBuffer() );

      int res ;
	  int pos = 0 ; 
	  while ( (pos = 1+ folder.Find('\\', pos )) != 0 ) 
         res = _mkdir( folder.Left(pos-1).GetBuffer() );
	  

	  res = _mkdir( folder.GetBuffer() );

      if ( res == -1 ) {
         errno_t err ;
         _get_errno ( &err) ;
         switch( err ) {
            case EEXIST :
               WriteLine (  "folder already exists...!" ) ; 
               break;
            case ENOENT :
               WriteLine (  "path was not found" ) ; 
               break;
            default: 
               break;
         }
      }

   } catch (...) {
      WriteLine (  "error creating folders" ) ;
      throw "error creating folders";
   }
}
//___________________________________________________________________________//
void CDlgConnect::CreateZoneListFile( const char* fname, 
                                      int brick_number, 
                                      int plate_number, 
                                      const char* map, 
                                      const char* rawfolder,
                                      int trial_number) 
{
   // CREATE SCAN ZONES FILE
   try{
      WriteLine( "Create Zone List File: %s", fname );
      fPred.CreateZoneListFile( fname, brick_number, plate_number, map, rawfolder , trial_number );
   } catch (...) {
      WriteLine(  "error writing file" );
      throw "error writing file";
   }
}
//___________________________________________________________________________//
void CDlgConnect::LaunchListScan( const char* ip, const char* zonelist, const char* scanconf ) 
{
   WriteLine(  "Launch listscan.exe..." ) ;
   try {
      System( "start %s %s %s %s",
         fPar.listscanpath,
         ip, 
         zonelist , 
         scanconf );

   } catch (...) {
      WriteLine( "error launch  list scan" ) ;
      throw "error launch list scan";
   }
   //   gcroot<System::Runtime::Remoting::Channels::ChannelServices::RegisterChannel ^> rc ;//( new TcpChannel() ) ; 
   //   gcroot<SySal::DAQSystem::ScanServer^> ScanSrv = 
   //   (SySal::DAQSystem::ScanServer)System::Runtime::Remoting::RemotingServices::Connect(typeof(SySal::DAQSystem::ScanServer), 
   // "tcp://" + args[0] + ":" + ((int)SySal::DAQSystem::OperaPort::ScanServer).ToString() + "/ScanServer.rem");

}
//___________________________________________________________________________//
void CDlgConnect::LaunchBatchLink( const char* rawfolder, const char* tlgfolder, 
                                   int plate_number, int trial_number ) 
{
   WriteLine( "Launch BatchLink.exe..." ) ;

   try {
	   for( int i=0; i<fPred.N(); i++ )
	   {
         System( "start %s /wait %s %s %s",
			   fPar.batchlinkpath,
			   fPred.GetPrediction(i)->RawDataFileName( rawfolder , plate_number, trial_number ), 
			   fPred.GetPrediction(i)->TlgDataFileName( tlgfolder , plate_number, trial_number ), 
			   fPar.batchlinkconfig );
      }
   } catch (...) {
      WriteLine( "error launch batch link" );

      throw "error launch batch link";
   }
}
//___________________________________________________________________________//
void CDlgConnect::LaunchTLGSel( double res_pos , double res_ang , double increase_with_slope,
                               const char* tlgfolder, int brick_number, int plate_number,
                               int trial_number ) 
{
   WriteLine( "Launch TLGSel.exe..." ) ;

   try {
	   for( int i=0; i<fPred.N(); i++ )
	   {
         TPrediction* p = fPred.GetPrediction(i) ;

         System(  "%s %s %s \"%s\" /micro",
			   fPar.tlgselpath,
            p->TlgDataFileName( tlgfolder , plate_number, trial_number ), 
            p->TlgSelectedDataFileName( tlgfolder , plate_number, trial_number ), 
            p->SelectionString(res_pos, res_ang, increase_with_slope) 
            );
	   }
   } catch (...) {
      WriteLine( "error launch TLGSel " );

      throw "error launch TLGSel ";
   }
}

//___________________________________________________________________________//
void CDlgConnect::LaunchTLG2TXT( const char* outputfname, const char* tlgfolder, 
                                int brick_number, int plate_number, int trial_number ) 
{
   WriteLine( "Launch TLG2TXT.exe..." ) ;

   try {
	   for( int i=0; i<fPred.N(); i++ )
	   {
         TPrediction* p = fPred.GetPrediction(i) ;

         System( "%s %s %s",
            fPar.tlg2txtpath,
            p->TlgSelectedDataFileName( tlgfolder , plate_number , trial_number ), 
            p->TxtSelectedDataFileName( tlgfolder , plate_number , trial_number ) 
            );
         
         try{
            p->ReadCandidates( p->TxtSelectedDataFileName(tlgfolder, plate_number, trial_number ) ) ; 
         } catch (...) { 
            WriteLine( "no candidates found (or file corrupted)" ) ;
         }
         WriteLine( "n. candidates: %d", p->NCandidates() ) ;
	   }

      WriteLine( fPred.PrintCandidates() ) ;
      fPred.SaveCandidates( outputfname, trial_number ) ;
      WriteLine( "append results to: %s", outputfname ) ;

   } catch (...) {
      WriteLine( "error launch TLG2TXT " );

      throw "error launch TLG2TXT ";
   }
}
//___________________________________________________________________________//
void CDlgConnect::LaunchTLG2TXTForManualCheck( const char* manualcheck_zonelist_fname, 
                                               const char* manualcheck_results_fname,
                                               const char* tlgfolder, int brick_number, 
                                               int plate_number , int trial_number, 
                                               const char* map, 
                                               double pos_tol , double slope_tol)
{
   WriteLine( "Launch TLG2TXT.exe..." ) ;

   try {
	   for( int i=0; i<fPred.N(); i++ )
	   {
         TPrediction* p = fPred.GetPrediction(i) ;

         System( "%s %s %s",
            fPar.tlg2txtpath,
            p->TlgSelectedDataFileName( tlgfolder , plate_number , trial_number ), 
      		p->TxtSelectedDataFileName( tlgfolder , plate_number , trial_number ) 
            );
         
         try{
            p->ReadCandidates( p->TxtSelectedDataFileName(tlgfolder, plate_number, trial_number ) ) ; 
         } catch (...) { 
            WriteLine( "no candidates found (or file corrupted)" ) ;
         }
         WriteLine( "n. candidates: %d", p->NCandidates() ) ;
	   }

      WriteLine( fPred.PrintCandidatesForManualCheck( manualcheck_results_fname, brick_number, plate_number, (float) m_ZPlate, trial_number, map, pos_tol, slope_tol ) ) ;
      
      fPred.CreateZoneListFileForManualCheck( manualcheck_zonelist_fname, manualcheck_results_fname, brick_number, plate_number, (float) m_ZPlate, trial_number, map, pos_tol, slope_tol ) ;

      WriteLine( "create : %s", manualcheck_zonelist_fname ) ;

   } catch (...) {
      WriteLine( "error launch TLG2TXT " );

      throw "error launch TLG2TXT ";
   }
}
//___________________________________________________________________________//
void CDlgConnect::OnBnClickedBtnLoadparameters()
{

   CFileDialog dlgFile( TRUE, "ini", "connect.ini", kFileDlgFlags, "Ini Files (*.ini)|*.ini|All Files (*.*)|*.*||" );
   INT_PTR nResult = dlgFile.DoModal() ;
   CString str = dlgFile.GetPathName().GetBuffer() ;
   UpdateData(FALSE) ; 

   m_strMessage = "" ;

   if ( fPar.ReadConfig( str.GetBuffer() )==0 ) {      
      WriteLine( "read parameters from %s ..." , str.GetBuffer() ) ;
   } else {      
      fPar.SetDefaults() ;      
      WriteLine( "read parameters from %s failed !\r\nload defaults..."
         , str.GetBuffer() ) ;
   }   

   WriteLine( "%s", fPar.ShowPar() );   
   }
//___________________________________________________________________________//
void CDlgConnect::OnBnClickedMarksetRadioCsspot()
{
   m_MarkSetType = kCSSPOT ; 
   WriteLine( "\r\nMarkSet type: CS-SPOT (%d)", m_MarkSetType ); 
   UpdateData() ;
}
//___________________________________________________________________________//
void CDlgConnect::OnBnClickedMarksetRadioLateral()
{
   m_MarkSetType = kLateral ; 
   WriteLine( "\r\nMarkSet type: LATERAL (%d)", m_MarkSetType );   
   UpdateData() ;
}
//___________________________________________________________________________//
void CDlgConnect::OnBnClickedBtnMergeresults()
{

   fPred.MergeResults( m_BrickNumber, m_strMergeResults.GetBuffer(), fPar.mcresultspath ) ;
   WriteLine( "\r\nMerge results to: %s ", m_strMergeResults.GetBuffer() );   
   System( "notepad %s ", m_strMergeResults.GetBuffer() ) ;

   UpdateData() ;
}
