// DlgConnect.h : header file
//

#pragma once

// C++ MANAGED ... attivare Configuration Parameters -> Common Language Runtime Support -> /clr
/*
//#ifdef ENABLE_NET
#include <vcclr.h>
//#endif
#using "DAQSystem.dll"
#using "SySalCore.dll"
#using "ScanServerScheme.dll"
*/


#include "csbrickconnect.h"

const int kCSSPOT   = 0 ;
const int kLateral  = 1 ;


// CDlgConnect dialog
class CDlgConnect : public CDialog
{
// Construction
public:
	CDlgConnect(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_CONNECT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
   afx_msg void OnBnClickedBtnLoadpredCS2();
   afx_msg void OnBnClickedBtnStart();

   BOOL UpdateData(BOOL bSaveAndValidate = 1 ) ;

// my Implementation
protected:
   void WriteLine( const char *format, ... ) ;
   int System( const char *format, ... ) ;

   void ReadPredictions( const char* fname ) ;
   void ProjectPredictions( double z ) ;
   void EvalScanZones( double size_x, double size_y ) ;
   void CreateWorkingFolders();

   void CreateFolder( CString folder ) ;

   CString ZoneListFileName()    ;
   CString ManualCheckZoneListFileName()    ;
   CString FoundFileName()       ;
   CString ManualCheckResultsFileName() ;
   void CreateZoneListFile( const char* fname, int brick_number, int plate_number, 
      const char* map, const char* rawfolder, int trial_number) ;
   void LaunchListScan( const char* ip, const char* zonelist, const char* scanconf ) ;
   void LaunchBatchLink( const char* rawfolder, const char* tlgfolder, int plate_number, int trial_number ) ;
   void LaunchTLGSel( double res_pos , double res_ang , double increase_with_slope,
                       const char* tlgfolder, int brick_number, int plate_number, int trial_number )   ;
   void LaunchTLG2TXT( const char* outputfname, const char* tlgfolder, int brick_number, int plate_number, int trial_number )   ;
   void LaunchTLG2TXTForManualCheck( const char* manualcheck_zonelist_fname, const char* manualcheck_results_fname, const char* tlgfolder, int brick_number, int plate_number , int trial_number,
                                     const char* map, double pos_tol , double slope_tol)   ;

// public members
public:
   CString m_strFilePredCS2 ;
   CString m_strMessage     ;

   TPredictionSet fPred ;

//protected members
protected:

   double m_ZPlate;

   TConfiguration fPar ;

public:
   double m_ScanZoneSize;
   double m_ZCS2;
   int m_BrickNumber;
   afx_msg void OnEnChangeEditBrickNumber();
   CString m_strFileCSSpotMarkSet;
   CString m_strFileLateralMarkSet;
   afx_msg void OnBnClickedBtnCSSpotMarkSet();
   afx_msg void OnBnClickedBtnLateralMarkSet();
   int m_PlateNumber;
   CString m_strFileWorkingFolder;
   afx_msg void OnBnClickedBtnWorkingFolder();
   CString m_strFileRawDataFolder;
   CString m_strFileTlgDataFolder;
   afx_msg void OnBnClickedBtnRawdataFolder();
   afx_msg void OnBnClickedBtnTlgdataFolder();
   afx_msg void OnBnClickedBtnScanningconfig();
   CString m_strScanningConfig;
   CString m_strScanServerIP;
   afx_msg void OnCbnSelchangeComboScanserver();
   afx_msg void OnBnClickedBtnLoadparameters();
   double m_dPositionTol;
   double m_dSlopeTol;
   double m_dIncreaseWithSlope;
   afx_msg void OnBnClickedBtnTracksel();
   double m_MCPosTol;
   double m_MCSlopeTol;
   afx_msg void OnBnClickedBtnManualchecks();
   CString m_strMCResults;
   CString m_strMCScanningConfig;
   CString m_strTrackSelResults;
   afx_msg void OnEnChangeEditPlateNumber();
   int m_TrialNumber;
   afx_msg void OnEnChangeEditTrial();
   afx_msg void OnBnClickedMarksetRadioCsspot();
   afx_msg void OnBnClickedMarksetRadioLateral();
   int m_MarkSetType ;
   CString m_strMergeResults;
   afx_msg void OnBnClickedBtnMergeresults();
};
